<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>fsqp</title>
</head>
<body bgcolor="#FFFFFF">
<center>Scilab Function  </center>
<div align="right">Last update : 11/09/2007</div>
<p><b>fsqp</b> -  sequentially related FSQP solver  </p>
<h3><font color="blue">Calling Sequence</font></h3>
<dl>
<dd><tt>x=srfsqp(x0,ipar,srpar,mesh_pts,rpar,[bl,bu],obj,cntr,grob,grcn)  </tt></dd>
<dd><tt>x=srfsqp(x0,ipar,srpar,mesh_pts,rpar,[bl,bu],obj,cntr,'grob','grcn')  </tt></dd>
<dd><tt>x=srfsqp(x0,ipar,srpar,mesh_pts,rpar,[bl,bu],'obj','cntr','grob','grcn', [cd])  </tt></dd>
<dd><tt>x=srfsqp(x0,ipar,srpar,mesh_pts,rpar,[bl,bu],'obj','cntr','grobfd','grcnfd', [cd])  </tt></dd>
<dd><tt>[x,inform]=srfsqp(...)  </tt></dd>
<dd><tt>[x,inform,f,g,lambda]=srfsqp(...)  </tt></dd>
</dl>
<h3><font color="blue">Parameters</font></h3>
<ul>
<li>
<tt><b>x0  </b></tt>
    : real column vector (initial guess)
  </li>
<li>
<tt><b>ipar  </b></tt>
    : integer vector of size 8.
  </li>
<li>
<tt><b>srpar  </b></tt>
    : integer vector of size 3.
  </li>
<li>
<tt><b>mesh_pts  </b></tt>
    : integer vector of size nfsr+ncsrn+ncsrl
  </li>
<li>
<tt><b>rpar  </b></tt>
    : real vector of size 4.
  </li>
<li>
<tt><b>[bl,bu]  </b></tt>
    : real matrix with 2 columns and same row dimension as x.
  </li>
<li>
<tt><b>obj, cntr  </b></tt>
    : name of scilab functions or character strings (name of C functions) defining the objective function and the constraints function.
  </li>
<li>
<tt><b>grob,grcn  </b></tt>
    : name of scilab functions or character strings (name of C functions) defining the gradient of objective function and the gradient of  constraints function.
  </li>
<li>
<tt><b>cd  </b></tt>
    : optional real vector (argument passed to C functions).
  </li>
</ul>
<h3><font color="blue">Description</font></h3>
<p>
    fsqp interface for SR problems. This interface uses the notations of the cfsqp
    user's guide (see c_manual.ps).
    The four functions (objective, constraints, gradient-of-objective,
    gradient-of-constraints) can be given either as C-functions dynamically
    linked with Scilab or as Scilab functions (mixtures are allowed).
    If a Scilab function is given as argument of fsqp, 
    just use its name (without quotes). If a C function is to be called,
    use a character string to define it. For instance fsqp(...,obj,...)
    invokes fsqp with the Scilab function <tt><b>obj</b></tt> and
    <tt><b>fsqp(...,"obj",...)</b></tt> invokes fsqp with the C function 
    <tt><b>obj</b></tt>, linked with Scilab by e.g. <tt><b> link("obj.o", "obj") </b></tt>.
  </p>
<p>
    The chains "grobfd" and "grcnfd" can be used as C functions to compute
    the gradients of the functions grob and cntr by finite difference.
    Notations:
  </p>
<pre>
ipar=[nf,nineqn,nineq,neqn,neq,modefsqp,miter,iprint];
srpar=[nfsr,ncsrl,ncsrn];
rpar=[bigbnd,eps,epsneq,udelta];
   </pre>
<pre>
function fj=obj(j,x)
function  gj=cntr(j,x)
function gradf=grob(j,x)
function gradgj=grcn(j,x)
   </pre>
<p>
    obj(j,x) returns the value of the jth objective, given x.
    cntr(j,x) returns the value of the jth constraint, given x.
    grob(j,x) (resp. grcn(j,x)) is the value at x of the gradient of the 
    function x-&gt;obj(j,x) (resp.  x-&gt;cntr(j,x)).
  </p>
<p>
    It may be useful to make use of the fsqp C variable x_is_new and to
    evaluate these functions in a vector way. For instance the function
    cntr can be replaced by the following cntr2 function:
  </p>
<pre>
function cj=cntr2(j,x)
if x_is_new() then
 all_objectives=allobj(x);
 all_constraints=allcntr(x);
 all_gradobjectives=allgrob(x);
 all_gradconstraints=allgrcn(x);
 cj=all_constraints(j);
 set_x_is_new(0);  //Use resume to define global Scilab variables
 [all_objectives,all_constraints,all_gradobjectives,all_gradconstraints]=....
 resume(all_objectives,all_constraints,all_gradobjectives,all_gradconstraints);
else
  cj=all_constraints(j);
end
   </pre>
<p>
    Here, the function allcntr(x) returns a vector all_constraints whose
    jth component all_constraints(j) is cntr(j).
    A typical example comes from discretized semi-infinite program. 
    See example5.sci.
  </p>
<h3><font color="blue">Examples</font></h3>
<pre>
// see demo 2 second part
 </pre>
<h3><font color="blue">See Also</font></h3>
<p><a href="fsqp.htm"><tt><b>fsqp</b></tt></a>,&nbsp;&nbsp;<a href="x_is_new.htm"><tt><b>x_is_new</b></tt></a>,&nbsp;&nbsp;<a href=""><tt><b>set_x_is_new</b></tt></a>,&nbsp;&nbsp;</p>
</body>
</html>
